package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.Result;
import com.platform.entity.UserCouponEntity;
import com.platform.service.UserCouponService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-19 15:40:33
 */
@RestController
@RequestMapping("usercoupon")
public class UserCouponController {
    @Autowired
    private UserCouponService userCouponService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")
    
    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<UserCouponEntity> userCouponList = userCouponService.queryList(query);
        int total = userCouponService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(userCouponList, total, query.getLimit(), query.getPage());

        return Result.success(pageUtil);
    }

    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")
    
    public Result info(@PathVariable("id") Integer id) {
        UserCouponEntity userCoupon = userCouponService.queryObject(id);

        return Result.success(userCoupon);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")
    
    public Result save(@RequestBody UserCouponEntity userCoupon) {
        userCouponService.save(userCoupon);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")
    
    public Result update(@RequestBody UserCouponEntity userCoupon) {
        userCouponService.update(userCoupon);

        return Result.success();
    }


    /**
     * 作废用户优惠券
     */
    @CanUserUpdateRecord
    @GetMapping("/cancelUserCoupon")
    
    public Result cancelUserCoupon(@RequestParam(name = "couponId") Integer couponId ,
                              @RequestParam(name = "userId") Long userId) {
        if(null == couponId || null == userId){
            return Result.failure("优惠券ID或者用户Id不能为空");
        }
        int update = userCouponService.cancelUserCoupon(couponId , userId);
        if(update != 1){
            Result.failure("作废失败");
        }
        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")
    
    public Result delete(@RequestBody Integer[] ids) {
        userCouponService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查看所有列表
     */
    @RequestMapping("/queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {

        List<UserCouponEntity> list = userCouponService.queryList(params);

        return Result.success(list);
    }
}
